//+------------------------------------------------------------------+
//|                                                         Faza.mq4 |
//|                             Copyright  2010, Avatara@bigmir.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Avatara@bigmir.net"
#property link      "Avatara@bigmir.net"
#property show_confirm
#property show_inputs
#define Max 999999999.99
extern int M=1350;
extern bool HTF=true;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {  
    int hFile,Tf1,N1,N2;
    int i=0,j=0,Records;
    string NameVal,aS[];
    bool flag=true, bS=false;
    int TF_PER[10];
    double ZZ, ZZ0,Val,Tf2;
    double aZZ, aForecast[], aVol, aSpeed; 
    string Name_Files;
    TF_PER[1]=1;  TF_PER[2]=5;    TF_PER[3]=15;    TF_PER[4]=30; 
    TF_PER[5]=60; TF_PER[6]=240;  TF_PER[7]=1440;  TF_PER[8]=10080;
    TF_PER[9]=43200;
    Tf1=Period();
    NameVal=Symbol();
    for( i=1; i<=8; i++)
      { 
       if (Tf1==TF_PER[i]) Tf2=TF_PER[i+1];
      }  
    Name_Files=StringConcatenate("F_",NameVal,Tf1,"_",
               TimeYear(Time[0]),"_",TimeMonth(Time[0]),"_",
               TimeDay(Time[0]),"X",TimeHour(Time[0]),"_",
               TimeMinute(Time[0]),".csv");
    Print ("Save Faza! ",Name_Files);
    hFile=FileOpen(Name_Files,FILE_CSV |FILE_WRITE,";");
    //++++++
    Print ("Tf1=",Tf1,"  Tf2=",Tf2);
    N1=Bars-1;N2=iBars(Symbol(),Tf2)-1;
     Print ("N1=",N1," N2=",N2);
    if (M<N1) N1=M;
    if (ND(N1)*ND(Tf1)/ND(Tf2)>=N2) N1=N2*Tf2/ND(Tf1);
        else N2=N1*ND(Tf1)/Tf2+1;
        Print ("N1=",N1," N2=",N2);
    ArrayResize(aForecast,N1+120);
    ArrayResize(aS,N1+120); 
    i=0;
    ZZ0=iCustom(NameVal,Tf1,"ZigZag",20,1,3,0,i);
    if (ZZ0==0)ZZ0=Max;
    bS=false;    
       
//-------------------------------------------------------------------*/         
  while (flag)
   {    
     if (iTime(NameVal,Tf1,i)<iTime(NameVal,Tf2,j))
                {  j++;
                Val=iCustom(NameVal,Tf2,"ZigZag",20,1,3,0,j);
                } 
      if (Val!=0) 
       { 
       ZZ=iCustom(NameVal,Tf1,"ZigZag",20,1,3,0,i);
       if (ZZ==Val)
        {
         ZZ0=Val;bS=!bS;Val=0;
         if (j>=N2+40) flag=false;
        }
       }
     aForecast[i]=ZZ0;
     aS[i]=bS;
     i++;  
     if (i+Tf2/ND(Tf1)>=N1+99) {flag=false;Print ("N1<",N1+99);}
   }  
    Print ("N1=",i," ",j);
    Records=i+Tf2/ND(Tf1);bS=!bS;
    for (i=Tf2/ND(Tf1);i>0;i--)
     {
     aForecast[Records-i]=ZZ0;
     aS[Records-i]=bS;
     }
    FileWrite(hFile,"# rec","Symbol","date","Time",
              "<O>","<C>","<L>","<H>","<V>",
              "DirectH","Forecast","ZZ","Direct",
              " F-ZZ"," |F-<C>|"," |<C>-ZZ|","ATR","ROC"
              );       
  for (i=Records;i>=0;i--)
    {  
       ZZ=iCustom(NameVal,Tf1,"ZigZag",20,1,3,0,i);
       if (ZZ!=0)
       { 
       bS=!bS;
        if (!HTF && MathAbs(ZZ-aForecast[i])>Point)
          ZZ0=ZZ;
         else if (MathAbs(ZZ-aForecast[i])<Point) 
          ZZ0=aForecast[i];
       }
        else  if (i==Records) {Records--;continue;} 
       if (aForecast[i]>=10000) {break;}
       aZZ=ZZ0;   
       aVol=iCustom(NameVal,Tf1,"ATR",14,0,i);
       aSpeed=iCustom(NameVal,Tf1,"ROC",14,0,i);  
              
    FileWrite(hFile,i,NameVal,dataConv(iTime(NameVal,Tf1,i)),
              iOpen(NameVal,Tf1,i),iClose(NameVal,Tf1,i),
              iLow(NameVal,Tf1,i),iHigh(NameVal,Tf1,i),
              iVolume(NameVal,Tf1,i),aS[i],
              aForecast[i],aZZ,bS
              ,(aForecast[i]-aZZ),
              (aForecast[i]-iClose(NameVal,Tf1,i)),
              (aZZ-iClose(NameVal,Tf1,i)),
              aVol,aSpeed
              );              
    } 
   FileClose(hFile);Print ("Finish! ", Records);
} 
 //+------------------------------------------------------------------+
string dataConv(datetime T){
  return(StringConcatenate(TimeYear(T),"/",TimeMonth(T),
  "/",TimeDay(T)," ;",TimeHour(T),":",TimeMinute(T)));}
//+------------------------------------------------------------------+
double ND(int Val){ return(Val);}